#!/bin/bash

TEST_CMD="./irciot-test.py"
if [ ! -x "${TEST_CMD}" ] ; then
 echo "Cannot find automatic test Python script"
fi

for i in \
default \
multidatum \
multibigval \
multinextbig \
; do
 export TEST_NAME="'${i}'"
 while export TEST_NAME="${TEST_NAME} " ; do
 TEST_LEN="$(expr length "${TEST_NAME}")"
 if [ ${TEST_LEN} -gt 16 ]; then break ; fi
 done
 echo -ne "Test ${TEST_NAME} "
 "${TEST_CMD}" "${i}" 2>/dev/null | \
  /usr/bin/head -n 2048 2>/dev/null | \
  /bin/grep -e "TEST_IS_OK" 1>/dev/null ; ERRLV=$?
 if [ ${ERRLV} -eq 0 ]; then
  echo -ne "- \033[1;32mok\033[0m\n"
 else
  echo -ne "- \033[1;31mfailed\033[0m\n"
 fi
done

exit 0
