#!/usr/bin/python3.5

import sys
import os
import json
from pprint import pprint
from irciot import CIRCIoT

ii = CIRCIoT()

# FOR TESTING:

def JSON_TEST_is_irciot_(my_json_text):
 print ("Testing JSON for IRC-IoT: @\033[1m%s\033[0m@len=%d@" \
  % (my_json_text, len(my_json_text)))
 if (len(my_json_text) > ii.message_mtu):
   print ("IRC-IoT Message length out of MTU range.")
   return False
 if (not ii.is_irciot_(my_json_text)):
   print ("is_irciot_() = *** This is not an IRC-IoT message ...")
   return False
 else:
   print ("is_irciot_() = !!! Yes, this is IRC-IoT message !!!")
   return True
   
def JSON_TEST_is_irciot_datumset_(my_datumset_text):
 print ("Testing Datums set: @\033[1m%s\033[0m@len=%d@" \
  % (my_datumset_text, len(my_datumset_text)))
 if (not ii.is_irciot_datumset_(my_datumset_text)):
   print ("is_irciot_datumset_() = *** This is not IRC-IoT datum set ...")
   return False
 else:
   print ("is_irciot_datumset_() = !!! Yes, this is IRC-IoT datum set !!!")
   return True

def main():

 my_command = ""
 if (len(sys.argv) > 1):
   my_command = sys.argv[1]
 if (my_command == ""):
   my_command = 'default'
   
 print ("TEST NAME: '%s'" % my_command)
  
 if (my_command == 'default'):
  my_skip = 0
  my_part = 0
  json_text  = '[{"mid":"1","oc":1,"op":1,"o":[{"oid":"x","ot":"maireq",'
  json_text += '"dst":"yyy","d":[{"src":"xxx","help":"super-string"}]}]}]'
  ii.is_irciot_(json_text)
  if JSON_TEST_is_irciot_(json_text):
   datumset_text = ii.irciot_deinencap_(json_text)
   print ("irciot_deinencap_()")
   if (JSON_TEST_is_irciot_datumset_(datumset_text)):
    json_text, my_skip, my_part \
     = ii.irciot_encap_(datumset_text, 0, 0)
    print("irciot_encap_(): skip = %d, part = %d." \
     % (my_skip, my_part))
    if JSON_TEST_is_irciot_(json_text):
     print("TEST_IS_OK")

 if (my_command == 'multidatum'):
  datumset_text  = '[{"ot":"maireq","dst":"MUSICA@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:48:07.115959",'
  datumset_text += '"src":"maiengine","cnd":{"temperature":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"MUSICA@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:48:07.116012",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"IPC1002@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:48:07.116048",'
  datumset_text += '"src":"maiengine","cnd":{"kidsdoor":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:48:08.11253",'
  datumset_text += '"src":"maiengine","cnd":{"temperature":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:48:08.11752",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:48:08.11788",'
  datumset_text += '"src":"maiengine","cnd":{"motion":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"MUSICA@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:49:07.115959",'
  datumset_text += '"src":"maiengine","cnd":{"temperature":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"MUSICA@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:49:07.116012",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"IPC1002@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:49:07.116048",'
  datumset_text += '"src":"maiengine","cnd":{"kidsdoor":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:49:08.11253",'
  datumset_text += '"src":"maiengine","cnd":{"temperature":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:49:08.11752",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:49:08.11788",'
  datumset_text += '"src":"maiengine","cnd":{"motion":"?"}}]'
  if JSON_TEST_is_irciot_datumset_(datumset_text):
   json_text, my_skip, my_part \
    = ii.irciot_encap_(datumset_text, 0, 0)
   print("irciot_encap_(): skip = %d, part = %d. aaaaaaaaa" \
    % (my_skip, my_part))
   if JSON_TEST_is_irciot_(json_text):
    test_ok = 1
    while ((my_skip > 0) or (my_part > 0)):
     json_text, my_skip, my_part \
      = ii.irciot_encap_(datumset_text, my_skip, my_part)
     print("irciot_encap_(): skip = %d, part = %d." \
      % (my_skip, my_part))
     if not JSON_TEST_is_irciot_(json_text):
      test_ok = 0
    if (test_ok == 1):
     print("TEST_IS_OK")
 
 if (my_command == 'multibigval'):
  datumset_text  = '[{"bigval":"realbigval-hello-wolrd-big-string-NNN-xxx55'
  datumset_text += '55zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz-vvvvvvvvvvvvvvvv'
  datumset_text += 'vvvvv-aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa-xxxxxxxxxx'
  datumset_text += 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
  datumset_text += 'vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv'
  datumset_text += 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
  datumset_text += 'xxxxxxxxxxxxxxxxxxx","ot":"maireq","dst":"MUSICA@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:48:07.115959","src":"maiengine",'
  datumset_text += '"cnd":{"temperature":"?"}},{"ot":"maireq",'
  datumset_text += '"dst":"MUSICA@Kidsroom","t":"2018-08-23 14:48:07.116012",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"IPC1002@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:48:07.116048",'
  datumset_text += '"src":"maiengine","cnd":{"kidsdoor":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:48:08.11253","src":"maiengine",'
  datumset_text += '"cnd":{"temperature":"?"}},{"ot":"maireq",'
  datumset_text += '"dst":"TUX2@Livingroom","t":"2018-08-23 14:48:08.11752",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}}]'
  if JSON_TEST_is_irciot_datumset_(datumset_text):
   json_text, my_skip, my_part \
    = ii.irciot_encap_(datumset_text, 0, 0)
   print("irciot_encap_(): skip = %d, part = %d." \
    % (my_skip, my_part))
   if JSON_TEST_is_irciot_(json_text):
    test_ok = 1
    while ((my_skip > 0) or (my_part > 0)):
     json_text, my_skip, my_part \
      = ii.irciot_encap_(datumset_text, my_skip, my_part)
     print("irciot_encap_(): skip = %d, part = %d." \
      % (my_skip, my_part))
     if not JSON_TEST_is_irciot_(json_text):
      test_ok = 0
    if (test_ok == 1):
     print("TEST_IS_OK")
     
 if (my_command == 'multinextbig'):
  datumset_text  = '[{"ot":"maireq","t":"2018-08-23 14:48:01.113333",'
  datumset_text += '"dst":"MUSICA@Kidsroom","src":"maireq",'
  datumset_text += '"cnd":{"relay3":"?"}},'
  datumset_text += '{"bigval":"realbigval-hello-wolrd-big-string-NNN-xxx55'
  datumset_text += '55zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz-vvvvvvvvvvvvvvvv'
  datumset_text += 'vvvvv-aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa-xxxxxxxxxx'
  datumset_text += 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
  datumset_text += 'nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn'
  datumset_text += 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
  datumset_text += 'xxxxxxxxxxxxxxxxxxx","ot":"maireq","dst":"MUSICA@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:48:07.115959","src":"maiengine",'
  datumset_text += '"cnd":{"temperature":"?"}},{"ot":"maireq",'
  datumset_text += '"dst":"MUSICA@Kidsroom","t":"2018-08-23 14:48:07.116012",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"IPC1002@Kidsroom",'
  datumset_text += '"t":"2018-08-23 14:48:07.116048",'
  datumset_text += '"src":"maiengine","cnd":{"kidsdoor":"?"}},'
  datumset_text += '{"ot":"maireq","dst":"TUX2@Livingroom",'
  datumset_text += '"t":"2018-08-23 14:48:08.11253","src":"maiengine",'
  datumset_text += '"cnd":{"temperature":"?"}},{"ot":"maireq",'
  datumset_text += '"dst":"TUX2@Livingroom","t":"2018-08-23 14:48:08.11752",'
  datumset_text += '"src":"maiengine","cnd":{"humidity":"?"}}]'
  if JSON_TEST_is_irciot_datumset_(datumset_text):
   json_text, my_skip, my_part \
    = ii.irciot_encap_(datumset_text, 0, 0)
   print("irciot_encap_(): skip = %d, part = %d." \
    % (my_skip, my_part))
   if JSON_TEST_is_irciot_(json_text):
    test_ok = 1
    while ((my_skip > 0) or (my_part > 0)):
     json_text, my_skip, my_part \
      = ii.irciot_encap_(datumset_text, my_skip, my_part)
     print("irciot_encap_(): skip = %d, part = %d." \
      % (my_skip, my_part))
     if not JSON_TEST_is_irciot_(json_text):
      test_ok = 0
    if (test_ok == 1):
     print("TEST_IS_OK")

main()

